## ffmpeg 7.1

=== debian/changelog ===
ffmpeg (7:7.1-3ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't use pocketsphinx, librav1e, jpeg-xl on i386 too
    - Force gcc-13 on s390x, fixing a failure during build with no log

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 17:49:59 +0100

ffmpeg (7:7.1-3) unstable; urgency=medium

  [ Diederik de Haas ]
  * d/copyright: Update for removed and moved files

  [ Sebastian Ramacher ]
  * debian/rules: Disable asm on riscv64
    See https://trac.ffmpeg.org/ticket/11258 for details

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 27 Oct 2024 18:31:51 +0100

ffmpeg (7:7.1-2) experimental; urgency=medium

  * debian/patches: Apply patches from upstream and skip tests using
    non-existing pmtchange.ts
  * debian/*.symbols:
    - Remove dropped internal symbol
    - Add new symbols

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 20 Oct 2024 16:03:45 +0200

ffmpeg (7:7.1-1) experimental; urgency=medium

  * New upstream version 7.1
  * debian/patches: Remove patches from upstream

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 19 Oct 2024 17:18:27 +0200

=== debian/control ===
Source: ffmpeg
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Reinhard Tartler <siretart@tauware.de>,
 Balint Reczey <balint@balintreczey.hu>,
 James Cowgill <jcowgill@debian.org>,
 Sebastian Ramacher <sramacher@debian.org>,
Rules-Requires-Root: no
Homepage: https://ffmpeg.org/
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/multimedia-team/ffmpeg.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/ffmpeg
Build-Depends-Indep:
# needed to minify the CSS files
 cleancss,
# Autogenerated documentation
 doxygen,
# needed to create the CSS files for the HTML manuals
 node-less,
# generates top level manual page listing
 tree,
Build-Depends:
# autodetected: hwaccels 'cuda_llvm'
 clang [amd64 arm64 i386 ppc64el],
 debhelper-compat (= 13),
# --enable-libglslang,
 glslang-dev,
# --enable-libflite
 flite1-dev,
# --enable-frei0r
 frei0r-plugins-dev <!pkg.ffmpeg.stage1>,
# --enable-ladspa
 ladspa-sdk <!pkg.ffmpeg.stage1>,
# --enable-libaom
 libaom-dev,
# --enable-libaribb24
 libaribb24-dev <!pkg.ffmpeg.noextra>,
# --enable-libass
 libass-dev,
# --enable-libbluray
 libbluray-dev <!pkg.ffmpeg.stage1>,
# --enable-libbs2b
 libbs2b-dev,
# autodetected: external library 'bzlib'
 libbz2-dev,
# --enable-libcaca
 libcaca-dev <!pkg.ffmpeg.stage1>,
# --enable-libcdio
 libcdio-paranoia-dev,
# --enable-libchromaprint
 libchromaprint-dev <!pkg.ffmpeg.stage1>,
# --enable-libcodec2
 libcodec2-dev,
# --enable-libdav1d
 libdav1d-dev,
# --enable-libdvdnav
 libdvdnav-dev <!pkg.ffmpeg.stage1>,
# --enable-libdvdread
 libdvdread-dev <!pkg.ffmpeg.stage1>,
# --enable-libdc1394
 libdc1394-dev [linux-any],
# autodetected
 libdrm-dev [linux-any],
# autodected: ffnvcodec
 libffmpeg-nvenc-dev [amd64 arm64 i386],
# --enable-libfontconfig
 libfontconfig-dev,
# --enable-libfreetype
 libfreetype-dev,
# --enable-fribidi
 libfribidi-dev,
# --enable-opengl
 libgl-dev,
# --enable-libgme
 libgme-dev,
# --enable-gnutls
 libgnutls28-dev,
# --enable-libgsm
 libgsm1-dev,
# --enable-libharfbuzz
 libharfbuzz-dev,
# Fails to be detected by configure script, if not also libavc1394-dev is installed.
# --enable-libiec61883
 libiec61883-dev [linux-any],
 libavc1394-dev [linux-any],
# --enable-libjack
 libjack-jackd2-dev <!pkg.ffmpeg.stage1>,
# --enable-libjxl
 libjxl-dev [!alpha !i386] <!pkg.ffmpeg.stage1>,
# --enable-lv2
 liblilv-dev <!pkg.ffmpeg.stage1>,
# autodetected for the tiff decoder
 liblzma-dev,
# --enable-libmp3lame
 libmp3lame-dev,
# --enable-libmysofa
 libmysofa-dev,
# --enable-openal
 libopenal-dev,
# --enable-libopencore_amrnb
 libopencore-amrnb-dev <!pkg.ffmpeg.noextra>,
# --enable-libopencore_amrwb
 libopencore-amrwb-dev <!pkg.ffmpeg.noextra>,
# --enable-libopenjpeg
 libopenjp2-7-dev (>= 2.1),
# --enable-libopenmpt
 libopenmpt-dev,
# --enable-libopus
 libopus-dev,
# --enable-libplacebo
 libplacebo-dev (>= 4.192) [linux-any] <!pkg.ffmpeg.stage1>,
# --enable-pocketsphinx
 libpocketsphinx-dev (>= 0.8+5prealpha+1-7~) [!alpha !hppa !i386 !ia64 !m68k !mips64el !powerpc !ppc64 !s390x !sparc64] <!pkg.ffmpeg.stage1>,
# --enable-libpulse
 libpulse-dev <!pkg.ffmpeg.stage1>,
# --enable-librabbitmq
 librabbitmq-dev <!pkg.ffmpeg.stage1>,
# --enable-librav1e
 librav1e-dev [!alpha !hppa !hurd-i386 !i386 !ia64 !m68k !sh4 !sparc64 !x32] <!pkg.ffmpeg.stage1>,
# --enable-librist
 librist-dev <!pkg.ffmpeg.stage1>,
# --enable-librubberband
 librubberband-dev,
# --enable-librsvg
 librsvg2-dev [!alpha !hppa !hurd-i386 !ia64 !m68k !sh4 !x32] <!pkg.ffmpeg.stage1>,
# autodetected: protocol 'sctp'
 libsctp-dev [linux-any] <!pkg.ffmpeg.stage1>,
# --enable-sdl2
 libsdl2-dev <!pkg.ffmpeg.stage1>,
# --enable-libshine
 libshine-dev (>= 3.0.0),
# --enable-libsmbclient (used only in -extra flavor)
 libsmbclient-dev (>= 4.13) [!hurd-i386] <!pkg.ffmpeg.noextra>,
# --enable-libsnappy
 libsnappy-dev,
# --enable-libsoxr
 libsoxr-dev,
# --enable-libspeex
 libspeex-dev,
# --enable-libsrt
 libsrt-gnutls-dev <!pkg.ffmpeg.stage1>,
# --enable-libssh
 libssh-dev <!pkg.ffmpeg.stage1>,
# --enable-libsvtav1
 libsvtav1enc-dev <!pkg.ffmpeg.stage1>,
# --enable-libtesseract (used only in -extra flavor)
 libtesseract-dev <!pkg.ffmpeg.noextra>,
# --enable-libtheora
 libtheora-dev,
# --enable-libtwolame
 libtwolame-dev,
# This is not necessary, see explanation in debian/rules.
# # --enable-libv4l2
# libv4l-dev [!hurd-any],
# autodetected: hwaccels 'h263_vaapi, mpeg2_vaapi, vc1_vaapi, h264_vaapi, mpeg4_vaapi, wmv3_vaapi'
 libva-dev (>= 1.3) [!hurd-any],
# autodetected: hwaccels 'h263_vdpau, mpeg2_vdpau, vc1_vdpau, h264_vdpau, mpeg4_vdpau, wmv3_vdpau, mpeg1_vdpau', decoders 'h264_vdpau, mpeg1_vdpau, mpeg4_vdpau, mpeg_vdpau, vc1_vdpau, wmv3_vdpau'
 libvdpau-dev,
# --enable-libvidstab
 libvidstab-dev,
# --enable-libvo_amrwbenc
 libvo-amrwbenc-dev <!pkg.ffmpeg.noextra>,
# --enable-libvorbis
 libvorbis-dev,
# --enable-libvpl
 libvpl-dev [amd64],
# --enable-libvpx
 libvpx-dev,
# autodetected: vulkan
 libvulkan-dev [linux-any],
# --enable-libwebp
 libwebp-dev,
# --enable-libx264
 libx264-dev <!pkg.ffmpeg.stage1>,
# --enable-libx265
 libx265-dev (>= 1.8),
# autodetected libxcb-shape
 libxcb-shape0-dev,
# autodetected libxcb-shm
 libxcb-shm0-dev,
# autodetected libxcb-xfixes
 libxcb-xfixes0-dev,
# --enable-libxml2
 libxml2-dev,
# autodetected xlib
 libxv-dev,
# --enable-libxvid
 libxvidcore-dev,
# --enable-libzimg
 libzimg-dev,
# --enable-libzmq
 libzmq3-dev <!pkg.ffmpeg.stage1>,
# --enable-libzvbi
 libzvbi-dev <!pkg.ffmpeg.stage1>,
# --enable-opencl
 ocl-icd-opencl-dev | opencl-dev,
# used to detect libraries
 pkgconf,
# HTML documentation
 texinfo,
# assembler optimizations
 nasm,
# autodetected zlib
 zlib1g-dev,
 gcc-13 [s390x], g++-13 [s390x]

Package: ffmpeg
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Suggests:
 ffmpeg-doc
Description: Tools for transcoding, streaming and playing of multimedia files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This package contains:
  * ffmpeg: a command line tool to convert multimedia files between formats
  * ffplay: a simple media player based on SDL and the FFmpeg libraries
  * ffprobe: a simple multimedia stream analyzer
  * qt-faststart: a utility to rearrange Quicktime files

Package: ffmpeg-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 libjs-bootstrap,
 ${misc:Depends}
Description: Documentation of the FFmpeg multimedia framework
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This package contains the HTML documentation for the FFmpeg multimedia
 framework including the API documentation created by doxygen and the manpages
 for the libraries.

Package: libavcodec61
Architecture: any
Section: libs
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Suggests:
 libcuda1 [amd64 arm64 i386],
 libnvcuvid1 [amd64 arm64 i386],
 libnvidia-encode1 [amd64 arm64 i386],
Description: FFmpeg library with de/encoders for audio/video codecs - runtime files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic encoding/decoding framework and
 contains multiple decoders and encoders for audio, video and subtitle streams,
 and several bitstream filters.
 .
 The shared architecture provides various services ranging from bit stream I/O
 to DSP optimizations, and makes it suitable for implementing robust and fast
 codecs as well as for experimentation.
 .
 This package contains the runtime files.

Package: libavcodec-extra61
Build-Profiles: <!pkg.ffmpeg.noextra>
Architecture: any
Section: libs
Multi-Arch: same
Conflicts: libavcodec61
Provides: libavcodec61 (= ${binary:Version})
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Suggests:
 libcuda1 [amd64 arm64 i386],
 libnvcuvid1 [amd64 arm64 i386],
 libnvidia-encode1 [amd64 arm64 i386],
Description: FFmpeg library with additional de/encoders for audio/video codecs
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic encoding/decoding framework and
 contains multiple decoders and encoders for audio, video and subtitle streams,
 and several bitstream filters.
 .
 The shared architecture provides various services ranging from bit stream I/O
 to DSP optimizations, and makes it suitable for implementing robust and fast
 codecs as well as for experimentation.
 .
 This package replaces the libavcodec60 package and contains the
 following additional codecs:
 .
  * ARIB STD-B24 Captions (Subtitle Decoder)
  * OpenCORE Adaptive Multi-Rate (AMR) Narrow-Band (Encoder/Decoder)
  * OpenCORE Adaptive Multi-Rate (AMR) Wide-Band (Decoder)
  * Android VisualOn Adaptive Multi-Rate (AMR) Wide-Band (Encoder)
 .
 Because this package links against libraries that are licensed under
 Apache License 2.0, the resulting binaries are distributed under the
 GPL version 3 or later.

Package: libavcodec-extra
Build-Profiles: <!pkg.ffmpeg.noextra>
Architecture: any
Section: metapackages
Multi-Arch: same
Depends:
 libavcodec-extra61 (= ${binary:Version}),
 ${misc:Depends}
Description: FFmpeg library with extra codecs (metapackage)
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This metapackage depends on the latest version of the libavcodec variant
 that offers additional codec support. Application packages can depend
 on it if they require or suggest this variant in a robust manner.

Package: libavcodec-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libavcodec61 (= ${binary:Version}),
 libavutil-dev (= ${binary:Version}),
 libswresample-dev (= ${binary:Version}),
 ${misc:Depends}
Description: FFmpeg library with de/encoders for audio/video codecs - development files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic encoding/decoding framework and
 contains multiple decoders and encoders for audio, video and subtitle streams,
 and several bitstream filters.
 .
 The shared architecture provides various services ranging from bit stream I/O
 to DSP optimizations, and makes it suitable for implementing robust and fast
 codecs as well as for experimentation.
 .
 This package contains the development files.

Package: libavdevice61
Architecture: any
Section: libs
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: FFmpeg library for handling input and output devices - runtime files
 FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
 mux, demux, stream, filter and play pretty much anything that humans and
 machines have created. It supports the most obscure ancient formats up to the
 cutting edge.
 .
 This library provides a generic framework for grabbing from and rendering to
 many common multimedia input/output devices, and supports several input and
 output devices, including Video4Linux2, VfW, DShow, and ALSA.

=== debian/rules ===
#!/usr/bin/make -f

export V=1

# sets DEBIAN_VERSION variable
include /usr/share/dpkg/pkg-info.mk

# Get the Debian version revision:
DEB_REVISION := $(word 2, $(subst -, ,$(DEB_VERSION)))

# sets DEB_HOST_* variables
include /usr/share/dpkg/architecture.mk

ifeq (s390x,$(DEB_HOST_ARCH))
	export CC=gcc-13
	export CXX=g++-13
endif

# Ubuntu ld adds -Bsymbolic-functions by default, but that prevents FFmpeg from building.
export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions

# Package name for the extra flavor.
SHLIB_PKGS := $(shell sed -nr '/extra/! s/^Package:[[:space:]]*(lib.*[0-9]+)[[:space:]]*$$/\1/p' debian/control)
EXTRA_PKGS := $(shell sed -nr 's/^Package:[[:space:]]*(.*extra[0-9]+)[[:space:]]*$$/\1/p' debian/control)
FLAVORS = standard static
ifeq ($(filter pkg.ffmpeg.noextra,$(DEB_BUILD_PROFILES)),)
FLAVORS += extra
endif

# Most possible features, compatible with effective licensing of GPLv2+
CONFIG := --prefix=/usr \
	--extra-version="$(DEB_REVISION)" \
	--toolchain=hardened \
	--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	--incdir=/usr/include/$(DEB_HOST_MULTIARCH) \
	--arch=$(DEB_HOST_ARCH_CPU) \
	--enable-gpl \
	--disable-stripping \
	--disable-libmfx \
	--disable-omx \
	--enable-gnutls \
	--enable-libaom \
	--enable-libass \
	--enable-libbs2b \
	--enable-libcdio \
	--enable-libcodec2 \
	--enable-libdav1d \
	--enable-libflite \
	--enable-libfontconfig \
	--enable-libfreetype \
	--enable-libfribidi \
	--enable-libglslang \
	--enable-libgme \
	--enable-libgsm \
	--enable-libharfbuzz \
	--enable-libmp3lame \
	--enable-libmysofa \
	--enable-libopenjpeg \
	--enable-libopenmpt \
	--enable-libopus \
	--enable-librubberband \
	--enable-libshine \
	--enable-libsnappy \
	--enable-libsoxr \
	--enable-libspeex \
	--enable-libtheora \
	--enable-libtwolame \
	--enable-libvidstab \
	--enable-libvorbis \
	--enable-libvpx \
	--enable-libwebp \
	--enable-libx265 \
	--enable-libxml2 \
	--enable-libxvid \
	--enable-libzimg \
	--enable-openal \
	--enable-opencl \
	--enable-opengl

# disable sndio, it's pulled in via libopenal-dev and autodetected
CONFIG += --disable-sndio

ifeq (amd64,$(DEB_HOST_ARCH))
	CONFIG += --enable-libvpl
else
	CONFIG += --disable-libvpl
endif

# The standard configuration only uses the shared CONFIG.
CONFIG_standard = --enable-shared

# Additional features, compatible with effective licensing of GPLv3+
CONFIG_extra = --enable-shared \
	--enable-version3 \
	--disable-doc \
	--disable-programs \
	--disable-static \
	--enable-libaribb24 \
	--enable-libopencore_amrnb \
	--enable-libopencore_amrwb \
	--enable-libtesseract \
	--enable-libvo_amrwbenc

# Do not enable libsmbclient support on hurd-i386
ifeq (,$(filter hurd-i386,$(DEB_HOST_ARCH)))
	CONFIG_extra += --enable-libsmbclient
endif

# Disable optimizations if requested.
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CONFIG += --disable-optimizations
endif

# Respect CC/CXX from the environment, if they differ from the default.
# Don't set them if they equal the default, because that disables autodetection needed for cross-building.
ifneq (cc,$(CC))
	CONFIG += --cc=$(CC)
endif
ifneq (g++,$(CXX))
	CONFIG += --cxx=$(CXX)
endif

# Some libraries are built only on linux.
ifeq (linux,$(DEB_HOST_ARCH_OS))
	CONFIG += --enable-libdc1394 \
		--enable-libdrm \
		--enable-libiec61883
endif

# ffmpeg is involved in build-dependency cycles with x264 and chromaprint, so disable them in stage one.
# Also disable
# - frei0r, which build-depends on opencv.
# - rav1e and rsvg2 for bootstrap to avoid a complete rust toolchain.
# - network protocols srt, ssh, zmq, rabbitmq, rist, ...
# - device access bluray, jack, dvd, ...
# - optional features pocketsphix, zvbi, ladsap, lv2, sdl2, ...
ifneq (,$(filter pkg.ffmpeg.stage1,$(DEB_BUILD_PROFILES)))
	CONFIG += \
		--disable-chromaprint \
		--disable-frei0r \
		--disable-ladspa \
		--disable-libbluray \
		--disable-libcaca \
		--disable-libdvdnav \
		--disable-libdvdread \
		--disable-libjack \
		--disable-libjxl \
		--disable-libplacebo \
		--disable-libpulse \
		--disable-librabbitmq \
		--disable-librav1e \
		--disable-librist \
		--disable-librsvg \
		--disable-libsrt \
		--disable-libssh \
		--disable-libsvtav1 \
		--disable-libx264 \
		--disable-libzmq \
		--disable-libzvbi \
		--disable-lv2 \
		--disable-pocketsphinx \
		--disable-sdl2
else
	CONFIG += \
		--enable-chromaprint \
		--enable-frei0r \
		--enable-ladspa \
		--enable-libbluray \
		--enable-libcaca \
		--enable-libdvdnav \
		--enable-libdvdread \
		--enable-libjack \
		--enable-libpulse \
		--enable-librabbitmq \
		--enable-librist \
		--enable-libsrt \
		--enable-libssh \
		--enable-libsvtav1 \
		--enable-libx264 \
		--enable-libzmq \
		--enable-libzvbi \
		--enable-lv2 \
		--enable-sdl2
# Some libraries are built only on linux.
ifeq (linux,$(DEB_HOST_ARCH_OS))
	CONFIG += --enable-libplacebo
else
	CONFIG += --disable-libplacebo
endif
# Rust is not available on most of ports.
ifeq (,$(filter alpha hppa hurd-i386 i386 ia64 m68k sh4 sparc64 x32,$(DEB_HOST_ARCH)))
	CONFIG += --enable-librav1e
else
	CONFIG += --disable-librav1e
endif
# avoid pocketsphinx on mips (bug#812335), alpha, i386, ia64 and big-endian (bug#968456)
ifeq (,$(filter mips% alpha i386 ia64,$(DEB_HOST_ARCH))$(filter big,$(DEB_HOST_ARCH_ENDIAN)))
	CONFIG += --enable-pocketsphinx
else
	CONFIG += --disable-pocketsphinx
endif
# avoid librsvg on almost all ports (bug#983344, bug#991556)
ifeq (,$(filter alpha hppa hurd-i386 ia64 m68k sh4 x32,$(DEB_HOST_ARCH)))
	CONFIG += --enable-librsvg
else
	CONFIG += --disable-librsvg
endif
# avoid libjxl on alpha and i386 for now
ifeq (,$(filter alpha i386,$(DEB_HOST_ARCH)))
	CONFIG += --enable-libjxl
else
	CONFIG += --disable-libjxl
endif
endif

# Disable ASM-based optimizations on riscv64.
# They are currently broken:
# * https://trac.ffmpeg.org/ticket/11258
ifneq (,$(filter riscv64,$(DEB_HOST_ARCH)))
	CONFIG += --disable-asm
endif

# Disable ASM-based optimizations on powerpc and ppc64el.
# They are currently not maintained and broken:
# * https://trac.ffmpeg.org/ticket/9604
# * https://trac.ffmpeg.org/ticket/10955
ifneq (,$(filter powerpc ppc64el,$(DEB_HOST_ARCH)))
	CONFIG += --disable-asm
endif

# Disable assembly optimizations on x32, because they don't work (yet).
ifneq (,$(filter x32,$(DEB_HOST_ARCH)))
	CONFIG += --disable-asm
endif

ifneq (,$(filter mips%,$(DEB_HOST_ARCH)))
	CONFIG += --disable-mipsdsp \
		--disable-mipsdspr2 \
		--disable-loongson2 \
		--disable-loongson3 \
		--disable-mmi \
		--disable-mips32r5 \
		$(MIPS_R2_R6_CONFIG) \
		--disable-msa
endif

# Disable some tests which fail when FLT_EVAL_METHOD != 0 (found on i386, m68k and s390x)
ifneq (,$(filter i386 m68k s390x,$(DEB_HOST_ARCH_CPU)))
	CONFIG += --ignore-tests=hapenc-hap-none,hapenc-hapa-none,hapenc-hapq-none
endif
# Disable new tests that were never successful on ppc64el
# (introduced in 5fdb5ed6132687219d0ef2127115ebaf95514058)
# https://trac.ffmpeg.org/ticket/9604
ifeq (ppc64el,$(DEB_HOST_ARCH))
	CONFIG += --ignore-tests=checkasm-sw_scale,filter-scale2ref_keep_aspect
endif
# https://trac.ffmpeg.org/ticket/9855
ifneq (,$(filter hppa m68k powerpc sparc64 s390x,$(DEB_HOST_ARCH_CPU)))
	CONFIG += --ignore-tests=filter-overlay_yuv420p10
endif
ifeq (ppc64,$(DEB_HOST_ARCH))
	CONFIG += --ignore-tests=checkasm-sw_scale,filter-overlay_yuv420p10
endif

# Set cross-build prefix for compiler, pkg-config...
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	CONFIG += --cross-prefix=$(DEB_HOST_GNU_TYPE)- \
		--target-os=$(DEB_HOST_ARCH_OS)
endif

%:
	dh $@

# Add configuration options:
override_dh_auto_configure: $(patsubst %,configure_%,$(FLAVORS))
configure_%:
	$(info $()   debian/rules $@)
	mkdir -p debian/$*
	cd debian/$* && ../../configure $(strip $(CONFIG) $(CONFIG_$*)) || (cat ffbuild/config.log && exit 1)

# Remove the subdirectories generated for the flavors.
override_dh_auto_clean:
	rm -rf $(patsubst %,debian/%,$(FLAVORS))

# Create doxygen documentation:
override_dh_auto_build-indep:

## ffmpeg 7.1.0

=== debian/changelog ===
ffmpeg (7:7.1.0-1ppa1~noble4) noble; urgency=medium

  * debian/control: Bump libvpl-dev dependency version

 -- Hoe, Sheng Yang <sheng.yang.hoe@intel.com>  Fri, 18 Jul 2025 20:34:25 +0800

ffmpeg (7:7.1.0-1ppa1~noble3) noble; urgency=medium

  *  d/patches: enable screen content tool encode for AV1
     - 0001-libavcodec-qsvenc-enable-Screen-Content-Tool-Encode-.patch

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Tue, 26 Nov 2024 14:01:20 +0800

ffmpeg (7:7.1.0-1ppa1~noble2) noble; urgency=medium

  *  d/patches: revert commit id 578ac59887 causing issue
     - 0001-Revert-lavfi-qsv-Copy-metadata-fields-from-the-given.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Thu, 17 Apr 2025 15:04:42 +0800

ffmpeg (7:7.1.0-1ppa1~noble1) noble; urgency=medium

  * new upstream version 7.1.0
  * d/patches: drop list of patches already upstream
    - 0001-avcodec-qsv-Use-RefStruct-API-for-memory-id-mids-arr.patch
    - 0002-lavu-hwcontext_qsv-update-AVQSVFramesContext-to-supp.patch
    - 0003-lavu-hwcontext_qsv-create-dynamic-frame-pool-if-requ.patch
    - 0004-lavu-hwcontext_qsv-add-support-for-dynamic-frame-poo.patch
    - 0005-lavu-hwcontext_qsv-add-support-for-dynamic-frame-poo.patch
    - 0006-lavc-qsv-fix-the-mfx-allocator-to-support-dynamic-fr.patch
    - 0007-lavc-qsvenc-use-the-right-info-for-encoding.patch
    - 0008-lavc-qsvdec-require-a-dynamic-frame-pool-if-possible.patch
    - 0009-lavfi-qsvvpp-use-the-right-mfxFrameInfo-when-dynamic.patch
    - 0010-lavfi-qsvvpp-require-a-dynamic-frame-pool-for-output.patch
    - 0011-lavu-hwcontext_vaapi-Add-option-to-allow-to-specify-.patch
    - 0012-lavu-hwcontext_qsv-Use-vendor-id-to-create-device.patch
    - 0013-lavc-qsv-Use-vendor-id-to-create-device.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Wed, 19 Mar 2025 16:28:06 +0800

ffmpeg (7:7.0.2-1ppa1~noble2) noble; urgency=medium
  * d/patches: fix XE initialize
    - 0011-lavu-hwcontext_vaapi-Add-option-to-allow-to-specify-.patch
    - 0012-lavu-hwcontext_qsv-Use-vendor-id-to-create-device.patch
    - 0013-lavc-qsv-Use-vendor-id-to-create-device.patch

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Tue, 26 Nov 2024 14:01:20 +0800

ffmpeg (7:7.0.2-1ppa1~noble1) noble; urgency=medium

  * New upstream version 7.0.2
  * d/patches: drop patches already merged.
    - 0001-avcodec-mpegvideo_enc-Fix-1-line-and-one-column-imag.patch
    - 0001-avcodec-ppc-h264dsp-Fix-left-shifts-of-negative-numb.patch
    - 0002-avcodec-lossless_videoencdsp-Don-t-presume-alignment.patch
    - 0003-avcodec-wavpack-Fix-leak-and-segfault-on-reallocatio.patch
    - 0004-fate-ffmpeg-Avoid-dependency-on-samples.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Wed, 28 Aug 2024 08:17:02 +0800

ffmpeg (7:7.0-1ppa1~noble3) noble; urgency=medium

  * d/patches: fixed CVE-2024-32230
    - 0001-avcodec-mpegvideo_enc-Fix-1-line-and-one-column-imag.patch

 -- Lim Siew Hoon <siew.hoon.lim@intel.com>  Mon, 26 Aug 2024 13:18:24 +0800

ffmpeg (7:7.0-1ppa1~noble2) noble; urgency=medium

  * d/patches: fixed fail run qsv transcode
    - 0001-avcodec-qsv-Use-RefStruct-API-for-memory-id-mids-arr.patch
    - 0002-lavu-hwcontext_qsv-update-AVQSVFramesContext-to-supp.patch
    - 0003-lavu-hwcontext_qsv-create-dynamic-frame-pool-if-requ.patch
    - 0004-lavu-hwcontext_qsv-add-support-for-dynamic-frame-poo.patch
    - 0005-lavu-hwcontext_qsv-add-support-for-dynamic-frame-poo.patch
    - 0006-lavc-qsv-fix-the-mfx-allocator-to-support-dynamic-fr.patch
    - 0007-lavc-qsvenc-use-the-right-info-for-encoding.patch
    - 0008-lavc-qsvdec-require-a-dynamic-frame-pool-if-possible.patch
    - 0009-lavfi-qsvvpp-use-the-right-mfxFrameInfo-when-dynamic.patch
    - 0010-lavfi-qsvvpp-require-a-dynamic-frame-pool-for-output.patch

 -- Lim Siew Hoon <siew.hoon.lim@intel.com>  Tue, 11 Jun 2024 12:32:57 +0800

ffmpeg (7:7.0-1ppa1~noble1) noble; urgency=medium

  * New upstream version 7.0
  * d/patches: drop list of patches no longer needed that use for GVP.
    - 0001-libavfilter-vf_overlay_qsv-Enable-N-input-overlay-wi.patch
    - 0001-libavformat-rtsp-exposed-TLS-args-for-RTSPS.patch
  * d/patches: already merged
    - 0001-lavf-rtpenc_jpeg-Retrieve-sampling-factor-from-SOF0.patch
  * d/patches: rebased patches
    - 0001-fftools-ffmpeg_mux-Use-same-thread-write_header-writ.patch
  * SONAME bumps:
    - libavcodec60 -> libavcodec61
    - libavdevice60 -> libavdevice61
    - libavfilter9 -> libavfilter10
    - libavformat60 -> libavformat61
    - libavutil58 -> libavutil59
    - libpostproc57 -> libpostproc58
    - libswresample4 -> libswresample5
    - libswscale7 -> libswscale8

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Fri, 26 Apr 2024 17:09:55 +0800

ffmpeg (7:6.0-1ppa1~jammy2) jammy; urgency=medium

  * debian/patches: Use same thread write_header/write_packet

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Tue, 05 Dec 2024 15:09:24 +0800

ffmpeg (7:6.0-1ppa1~jammy1) jammy; urgency=medium

  * New upstream version 6.0
  * debian/patches: drop list of patches already merged and rebased patches.
  * SONAME bumps
    - libavcodec59 -> libavcodec60
    - libavdevice59 -> libavdevice60
    - libavfilter8 -> libavfilter9
    - libavformat59 -> libavformat60
    - libavutil57 -> libavutil58
    - libpostproc56 -> libpostproc57
    - libswscale6 -> libswscale7
  * debian/copyright:
    - Update copyright years
    - Update file paths
  * debian/control: Remove lbgl1-mesa-dev from Build-Depends

 -- Lim Siew Hoon <siew.hoon.lim@intel.com>  Tue, 13 Jun 2023 10:54:07 +0800

ffmpeg (7:5.1-1ppa1~jammy9) jammy; urgency=medium

  * debian/patches: add av1_qsv encoder

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Fri, 07 Apr 2023 18:31:35 +0800

ffmpeg (7:5.1-1ppa1~jammy8) jammy; urgency=medium

  * debian/patches: Updated stack filters with addtional patches

 -- Prathaban, Thinesh <thinesh.prathaban@intel.com>  Tue, 21 Feb 2023 16:50:17 +0800



=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  Sebastian Ramacher <sramacher@debian.org>,
 Rules-Requires-Root: no
 Homepage: https://ffmpeg.org/
-Standards-Version: 4.6.2
+Standards-Version: 4.7.1
 Vcs-Git: https://salsa.debian.org/multimedia-team/ffmpeg.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/ffmpeg
 Build-Depends-Indep:
@@ -88,7 +88,7 @@
 # --enable-libjack
  libjack-jackd2-dev <!pkg.ffmpeg.stage1>,
 # --enable-libjxl
- libjxl-dev [!alpha !i386] <!pkg.ffmpeg.stage1>,
+ libjxl-dev [!alpha] <!pkg.ffmpeg.stage1>,
 # --enable-lv2
  liblilv-dev <!pkg.ffmpeg.stage1>,
 # autodetected for the tiff decoder
@@ -112,13 +112,13 @@
 # --enable-libplacebo
  libplacebo-dev (>= 4.192) [linux-any] <!pkg.ffmpeg.stage1>,
 # --enable-pocketsphinx
- libpocketsphinx-dev (>= 0.8+5prealpha+1-7~) [!alpha !hppa !i386 !ia64 !m68k !mips64el !powerpc !ppc64 !s390x !sparc64] <!pkg.ffmpeg.stage1>,
+ libpocketsphinx-dev (>= 0.8+5prealpha+1-7~) [!alpha !hppa !ia64 !m68k !mips64el !powerpc !ppc64 !s390x !sparc64] <!pkg.ffmpeg.stage1>,
 # --enable-libpulse
  libpulse-dev <!pkg.ffmpeg.stage1>,
 # --enable-librabbitmq
  librabbitmq-dev <!pkg.ffmpeg.stage1>,
 # --enable-librav1e
- librav1e-dev [!alpha !hppa !hurd-i386 !i386 !ia64 !m68k !sh4 !sparc64 !x32] <!pkg.ffmpeg.stage1>,
+ librav1e-dev [!alpha !hppa !hurd-i386 !ia64 !m68k !sh4 !sparc64 !x32] <!pkg.ffmpeg.stage1>,
 # --enable-librist
  librist-dev <!pkg.ffmpeg.stage1>,
 # --enable-librubberband
@@ -165,7 +165,7 @@
 # --enable-libvorbis
  libvorbis-dev,
 # --enable-libvpl
- libvpl-dev [amd64],
+ libvpl-dev (>=1:2.14.0-1ppa1~noble1) [amd64],
 # --enable-libvpx
  libvpx-dev,
 # autodetected: vulkan
@@ -203,8 +203,7 @@
 # assembler optimizations
  nasm,
 # autodetected zlib
- zlib1g-dev,
- gcc-13 [s390x], g++-13 [s390x]
+ zlib1g-dev
 
 Package: ffmpeg
 Architecture: any
@@ -232,7 +231,7 @@
 Multi-Arch: foreign
 Depends:
  libjs-jquery,
- libjs-bootstrap,
+ libjs-bootstrap5,
  ${misc:Depends}
 Description: Documentation of the FFmpeg multimedia framework
  FFmpeg is the leading multimedia framework, able to decode, encode, transcode,
@@ -370,3 +369,4 @@
  This library provides a generic framework for grabbing from and rendering to
  many common multimedia input/output devices, and supports several input and
  output devices, including Video4Linux2, VfW, DShow, and ALSA.
+ .

## ffmpeg 7.1.1

=== libavcodec/aarch64/Makefile ===
# subsystems
OBJS-$(CONFIG_AC3DSP)                   += aarch64/ac3dsp_init_aarch64.o
OBJS-$(CONFIG_FDCTDSP)                  += aarch64/fdctdsp_init_aarch64.o
OBJS-$(CONFIG_FMTCONVERT)               += aarch64/fmtconvert_init.o
OBJS-$(CONFIG_H264CHROMA)               += aarch64/h264chroma_init_aarch64.o
OBJS-$(CONFIG_H264DSP)                  += aarch64/h264dsp_init_aarch64.o
OBJS-$(CONFIG_H264PRED)                 += aarch64/h264pred_init.o
OBJS-$(CONFIG_H264QPEL)                 += aarch64/h264qpel_init_aarch64.o
OBJS-$(CONFIG_HPELDSP)                  += aarch64/hpeldsp_init_aarch64.o
OBJS-$(CONFIG_IDCTDSP)                  += aarch64/idctdsp_init_aarch64.o
OBJS-$(CONFIG_ME_CMP)                   += aarch64/me_cmp_init_aarch64.o
OBJS-$(CONFIG_MPEGAUDIODSP)             += aarch64/mpegaudiodsp_init.o
OBJS-$(CONFIG_MPEGVIDEOENC)             += aarch64/mpegvideoencdsp_init.o
OBJS-$(CONFIG_NEON_CLOBBER_TEST)        += aarch64/neontest.o
OBJS-$(CONFIG_PIXBLOCKDSP)              += aarch64/pixblockdsp_init_aarch64.o
OBJS-$(CONFIG_VIDEODSP)                 += aarch64/videodsp_init.o
OBJS-$(CONFIG_VP8DSP)                   += aarch64/vp8dsp_init_aarch64.o

# decoders/encoders
OBJS-$(CONFIG_AAC_DECODER)              += aarch64/aacpsdsp_init_aarch64.o \
                                           aarch64/sbrdsp_init_aarch64.o
OBJS-$(CONFIG_DCA_DECODER)              += aarch64/synth_filter_init.o
OBJS-$(CONFIG_OPUS_DECODER)             += aarch64/opusdsp_init.o
OBJS-$(CONFIG_RV40_DECODER)             += aarch64/rv40dsp_init_aarch64.o
OBJS-$(CONFIG_VC1DSP)                   += aarch64/vc1dsp_init_aarch64.o
OBJS-$(CONFIG_VORBIS_DECODER)           += aarch64/vorbisdsp_init.o
OBJS-$(CONFIG_VP9_DECODER)              += aarch64/vp9dsp_init_10bpp_aarch64.o \
                                           aarch64/vp9dsp_init_12bpp_aarch64.o \
                                           aarch64/vp9mc_aarch64.o             \
                                           aarch64/vp9dsp_init_aarch64.o

# ARMv8 optimizations

# subsystems
ARMV8-OBJS-$(CONFIG_VIDEODSP)           += aarch64/videodsp.o

# NEON optimizations

# subsystems
NEON-OBJS-$(CONFIG_AAC_DECODER)         += aarch64/sbrdsp_neon.o
NEON-OBJS-$(CONFIG_AC3DSP)              += aarch64/ac3dsp_neon.o
NEON-OBJS-$(CONFIG_FDCTDSP)             += aarch64/fdctdsp_neon.o
NEON-OBJS-$(CONFIG_FMTCONVERT)          += aarch64/fmtconvert_neon.o
NEON-OBJS-$(CONFIG_H264CHROMA)          += aarch64/h264cmc_neon.o
NEON-OBJS-$(CONFIG_H264DSP)             += aarch64/h264dsp_neon.o              \
                                           aarch64/h264idct_neon.o
NEON-OBJS-$(CONFIG_H264PRED)            += aarch64/h264pred_neon.o
NEON-OBJS-$(CONFIG_H264QPEL)            += aarch64/h264qpel_neon.o             \
                                           aarch64/hpeldsp_neon.o
NEON-OBJS-$(CONFIG_HPELDSP)             += aarch64/hpeldsp_neon.o
NEON-OBJS-$(CONFIG_IDCTDSP)             += aarch64/idctdsp_neon.o              \
                                           aarch64/simple_idct_neon.o
NEON-OBJS-$(CONFIG_ME_CMP)              += aarch64/me_cmp_neon.o
NEON-OBJS-$(CONFIG_MPEGAUDIODSP)        += aarch64/mpegaudiodsp_neon.o
NEON-OBJS-$(CONFIG_MPEGVIDEOENC)        += aarch64/mpegvideoencdsp_neon.o
NEON-OBJS-$(CONFIG_PIXBLOCKDSP)         += aarch64/pixblockdsp_neon.o
NEON-OBJS-$(CONFIG_VC1DSP)              += aarch64/vc1dsp_neon.o
NEON-OBJS-$(CONFIG_VP8DSP)              += aarch64/vp8dsp_neon.o

# decoders/encoders
NEON-OBJS-$(CONFIG_AAC_DECODER)         += aarch64/aacpsdsp_neon.o
NEON-OBJS-$(CONFIG_DCA_DECODER)         += aarch64/synth_filter_neon.o
NEON-OBJS-$(CONFIG_OPUS_DECODER)        += aarch64/opusdsp_neon.o
NEON-OBJS-$(CONFIG_VORBIS_DECODER)      += aarch64/vorbisdsp_neon.o
NEON-OBJS-$(CONFIG_VP9_DECODER)         += aarch64/vp9itxfm_16bpp_neon.o       \
                                           aarch64/vp9itxfm_neon.o             \
                                           aarch64/vp9lpf_16bpp_neon.o         \
                                           aarch64/vp9lpf_neon.o               \
                                           aarch64/vp9mc_16bpp_neon.o          \
                                           aarch64/vp9mc_neon.o
NEON-OBJS-$(CONFIG_HEVC_DECODER)        += aarch64/hevcdsp_deblock_neon.o      \
                                           aarch64/hevcdsp_idct_neon.o         \
                                           aarch64/hevcdsp_init_aarch64.o      \
                                           aarch64/h26x/epel_neon.o            \
                                           aarch64/h26x/qpel_neon.o            \
                                           aarch64/h26x/sao_neon.o

=== libavcodec/hevc/Makefile ===
clean::
	$(RM) $(CLEANSUFFIXES:%=libavcodec/hevc/%)

OBJS-$(CONFIG_HEVC_DECODER) += \
    hevc/cabac.o               \
    hevc/data.o                \
    hevc/dsp.o                 \
    hevc/filter.o              \
    hevc/hevcdec.o             \
    hevc/mvs.o                 \
    hevc/pred.o                \
    hevc/refs.o                \

OBJS-$(CONFIG_HEVC_PARSER) += \
    hevc/parser.o             \


OBJS-$(CONFIG_HEVCPARSE) += \
    hevc/data.o             \
    hevc/parse.o            \
    hevc/ps.o               \


OBJS-$(CONFIG_HEVC_SEI) +=  \
    hevc/sei.o              \


libavcodec/hevc/%.o: CPPFLAGS += -I$(SRC_PATH)/libavcodec/

=== debian/changelog ===
ffmpeg (7:7.1.1-1ubuntu4) questing; urgency=medium

  * SECURITY UPDATE: Stack-based buffer overflow in AAC Encoder
    - debian/patches/CVE-2025-1594.patch: aacenc_tns: clamp filter
      direction energy measurement
    - CVE-2025-1594

 -- John Breton <john.breton@canonical.com>  Wed, 03 Sep 2025 11:40:56 -0400

ffmpeg (7:7.1.1-1ubuntu3) questing; urgency=medium

  * Rebuild to include updated RISC-V base ISA RVA23

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Thu, 28 Aug 2025 11:22:25 +0000

ffmpeg (7:7.1.1-1ubuntu2) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 21 May 2025 08:17:23 +0200

ffmpeg (7:7.1.1-1ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't use pocketsphinx, librav1e, jpeg-xl on i386 too

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 10 Mar 2025 07:33:39 +0100

ffmpeg (7:7.1.1-1) unstable; urgency=medium

  * New upstream version 7.1.1
    - Fix out-of-bounds read (CVE-2025-0518)
  * debian/control: Bump Standards-Version
  * debian/patches: Remove patches included upstream

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 08 Mar 2025 10:34:57 +0100

ffmpeg (7:7.1-4ubuntu2) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Don't use pocketsphinx, librav1e, jpeg-xl on i386 too

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 24 Feb 2025 07:57:19 +0100

ffmpeg (7:7.1-4ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't use pocketsphinx, librav1e, jpeg-xl on i386 too
    - Force gcc-13 on s390x, fixing a failure during build with no log

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 22 Feb 2025 09:29:53 +0100

ffmpeg (7:7.1-4) unstable; urgency=medium

  [ Santiago Ruano Rincón ]
  * Move build-dependency from libjs-bootstrap to libjs-bootstrap5
    (Closes: #1088454)

  [ Sebastian Ramacher ]
  * debian/control: Bump Standards-Version

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 21 Feb 2025 13:16:27 +0100

ffmpeg (7:7.1-3ubuntu3) plucky; urgency=medium

  * Rebuild against latest jpeg-xl

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 08 Feb 2025 14:43:09 -0500

ffmpeg (7:7.1-3ubuntu2) plucky; urgency=medium

  * No-change rebuild for x265.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 23 Jan 2025 12:20:05 +0000

=== debian/rules ===
--- 
+++ 
@@ -10,11 +10,6 @@
 
 # sets DEB_HOST_* variables
 include /usr/share/dpkg/architecture.mk
-
-ifeq (s390x,$(DEB_HOST_ARCH))
-	export CC=gcc-13
-	export CXX=g++-13
-endif
 
 # Ubuntu ld adds -Bsymbolic-functions by default, but that prevents FFmpeg from building.
 export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions
@@ -284,3 +279,4 @@
 
 # Create doxygen documentation:
 override_dh_auto_build-indep:
+	dh_auto_build -i --sourcedirectory=debian/standard -- apidoc documentation
